git-submodule.shon commit http: respect protocol.*.allow=user for http-alternates (abcbdc0)
   1#!/bin/sh
   2#
   3# git-submodule.sh: add, init, update or list git submodules
   4#
   5# Copyright (c) 2007 Lars Hjemli
   6
   7dashless=$(basename "$0" | sed -e 's/-/ /')
   8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
   9   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
  10   or: $dashless [--quiet] init [--] [<path>...]
  11   or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
  12   or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
  13   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
  14   or: $dashless [--quiet] foreach [--recursive] <command>
  15   or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
  16OPTIONS_SPEC=
  17SUBDIRECTORY_OK=Yes
  18. git-sh-setup
  19. git-sh-i18n
  20. git-parse-remote
  21require_work_tree
  22wt_prefix=$(git rev-parse --show-prefix)
  23cd_to_toplevel
  24
  25# Tell the rest of git that any URLs we get don't come
  26# directly from the user, so it can apply policy as appropriate.
  27GIT_PROTOCOL_FROM_USER=0
  28export GIT_PROTOCOL_FROM_USER
  29
  30command=
  31branch=
  32force=
  33reference=
  34cached=
  35recursive=
  36init=
  37files=
  38remote=
  39nofetch=
  40update=
  41prefix=
  42custom_name=
  43depth=
  44
  45die_if_unmatched ()
  46{
  47        if test "$1" = "#unmatched"
  48        then
  49                exit 1
  50        fi
  51}
  52
  53#
  54# Print a submodule configuration setting
  55#
  56# $1 = submodule name
  57# $2 = option name
  58# $3 = default value
  59#
  60# Checks in the usual git-config places first (for overrides),
  61# otherwise it falls back on .gitmodules.  This allows you to
  62# distribute project-wide defaults in .gitmodules, while still
  63# customizing individual repositories if necessary.  If the option is
  64# not in .gitmodules either, print a default value.
  65#
  66get_submodule_config () {
  67        name="$1"
  68        option="$2"
  69        default="$3"
  70        value=$(git config submodule."$name"."$option")
  71        if test -z "$value"
  72        then
  73                value=$(git config -f .gitmodules submodule."$name"."$option")
  74        fi
  75        printf '%s' "${value:-$default}"
  76}
  77
  78isnumber()
  79{
  80        n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
  81}
  82
  83# Sanitize the local git environment for use within a submodule. We
  84# can't simply use clear_local_git_env since we want to preserve some
  85# of the settings from GIT_CONFIG_PARAMETERS.
  86sanitize_submodule_env()
  87{
  88        save_config=$GIT_CONFIG_PARAMETERS
  89        clear_local_git_env
  90        GIT_CONFIG_PARAMETERS=$save_config
  91        export GIT_CONFIG_PARAMETERS
  92}
  93
  94#
  95# Add a new submodule to the working tree, .gitmodules and the index
  96#
  97# $@ = repo path
  98#
  99# optional branch is stored in global branch variable
 100#
 101cmd_add()
 102{
 103        # parse $args after "submodule ... add".
 104        reference_path=
 105        while test $# -ne 0
 106        do
 107                case "$1" in
 108                -b | --branch)
 109                        case "$2" in '') usage ;; esac
 110                        branch=$2
 111                        shift
 112                        ;;
 113                -f | --force)
 114                        force=$1
 115                        ;;
 116                -q|--quiet)
 117                        GIT_QUIET=1
 118                        ;;
 119                --reference)
 120                        case "$2" in '') usage ;; esac
 121                        reference_path=$2
 122                        shift
 123                        ;;
 124                --reference=*)
 125                        reference_path="${1#--reference=}"
 126                        ;;
 127                --name)
 128                        case "$2" in '') usage ;; esac
 129                        custom_name=$2
 130                        shift
 131                        ;;
 132                --depth)
 133                        case "$2" in '') usage ;; esac
 134                        depth="--depth=$2"
 135                        shift
 136                        ;;
 137                --depth=*)
 138                        depth=$1
 139                        ;;
 140                --)
 141                        shift
 142                        break
 143                        ;;
 144                -*)
 145                        usage
 146                        ;;
 147                *)
 148                        break
 149                        ;;
 150                esac
 151                shift
 152        done
 153
 154        if test -n "$reference_path"
 155        then
 156                is_absolute_path "$reference_path" ||
 157                reference_path="$wt_prefix$reference_path"
 158
 159                reference="--reference=$reference_path"
 160        fi
 161
 162        repo=$1
 163        sm_path=$2
 164
 165        if test -z "$sm_path"; then
 166                sm_path=$(printf '%s\n' "$repo" |
 167                        sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 168        fi
 169
 170        if test -z "$repo" || test -z "$sm_path"; then
 171                usage
 172        fi
 173
 174        is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
 175
 176        # assure repo is absolute or relative to parent
 177        case "$repo" in
 178        ./*|../*)
 179                test -z "$wt_prefix" ||
 180                die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
 181
 182                # dereference source url relative to parent's url
 183                realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
 184                ;;
 185        *:*|/*)
 186                # absolute url
 187                realrepo=$repo
 188                ;;
 189        *)
 190                die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
 191        ;;
 192        esac
 193
 194        # normalize path:
 195        # multiple //; leading ./; /./; /../; trailing /
 196        sm_path=$(printf '%s/\n' "$sm_path" |
 197                sed -e '
 198                        s|//*|/|g
 199                        s|^\(\./\)*||
 200                        s|/\(\./\)*|/|g
 201                        :start
 202                        s|\([^/]*\)/\.\./||
 203                        tstart
 204                        s|/*$||
 205                ')
 206        git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
 207        die "$(eval_gettext "'\$sm_path' already exists in the index")"
 208
 209        if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
 210        then
 211                eval_gettextln "The following path is ignored by one of your .gitignore files:
 212\$sm_path
 213Use -f if you really want to add it." >&2
 214                exit 1
 215        fi
 216
 217        if test -n "$custom_name"
 218        then
 219                sm_name="$custom_name"
 220        else
 221                sm_name="$sm_path"
 222        fi
 223
 224        # perhaps the path exists and is already a git repo, else clone it
 225        if test -e "$sm_path"
 226        then
 227                if test -d "$sm_path"/.git || test -f "$sm_path"/.git
 228                then
 229                        eval_gettextln "Adding existing repo at '\$sm_path' to the index"
 230                else
 231                        die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
 232                fi
 233
 234        else
 235                if test -d ".git/modules/$sm_name"
 236                then
 237                        if test -z "$force"
 238                        then
 239                                echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
 240                                GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
 241                                echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
 242                                echo >&2 "  $realrepo"
 243                                echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
 244                                die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
 245                        else
 246                                echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
 247                        fi
 248                fi
 249                git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
 250                (
 251                        sanitize_submodule_env
 252                        cd "$sm_path" &&
 253                        # ash fails to wordsplit ${branch:+-b "$branch"...}
 254                        case "$branch" in
 255                        '') git checkout -f -q ;;
 256                        ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
 257                        esac
 258                ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
 259        fi
 260        git config submodule."$sm_name".url "$realrepo"
 261
 262        git add $force "$sm_path" ||
 263        die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
 264
 265        git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
 266        git config -f .gitmodules submodule."$sm_name".url "$repo" &&
 267        if test -n "$branch"
 268        then
 269                git config -f .gitmodules submodule."$sm_name".branch "$branch"
 270        fi &&
 271        git add --force .gitmodules ||
 272        die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
 273}
 274
 275#
 276# Execute an arbitrary command sequence in each checked out
 277# submodule
 278#
 279# $@ = command to execute
 280#
 281cmd_foreach()
 282{
 283        # parse $args after "submodule ... foreach".
 284        while test $# -ne 0
 285        do
 286                case "$1" in
 287                -q|--quiet)
 288                        GIT_QUIET=1
 289                        ;;
 290                --recursive)
 291                        recursive=1
 292                        ;;
 293                -*)
 294                        usage
 295                        ;;
 296                *)
 297                        break
 298                        ;;
 299                esac
 300                shift
 301        done
 302
 303        toplevel=$(pwd)
 304
 305        # dup stdin so that it can be restored when running the external
 306        # command in the subshell (and a recursive call to this function)
 307        exec 3<&0
 308
 309        {
 310                git submodule--helper list --prefix "$wt_prefix" ||
 311                echo "#unmatched"
 312        } |
 313        while read mode sha1 stage sm_path
 314        do
 315                die_if_unmatched "$mode"
 316                if test -e "$sm_path"/.git
 317                then
 318                        displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
 319                        say "$(eval_gettext "Entering '\$displaypath'")"
 320                        name=$(git submodule--helper name "$sm_path")
 321                        (
 322                                prefix="$prefix$sm_path/"
 323                                sanitize_submodule_env
 324                                cd "$sm_path" &&
 325                                sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
 326                                # we make $path available to scripts ...
 327                                path=$sm_path &&
 328                                if test $# -eq 1
 329                                then
 330                                        eval "$1"
 331                                else
 332                                        "$@"
 333                                fi &&
 334                                if test -n "$recursive"
 335                                then
 336                                        cmd_foreach "--recursive" "$@"
 337                                fi
 338                        ) <&3 3<&- ||
 339                        die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
 340                fi
 341        done
 342}
 343
 344#
 345# Register submodules in .git/config
 346#
 347# $@ = requested paths (default to all)
 348#
 349cmd_init()
 350{
 351        # parse $args after "submodule ... init".
 352        while test $# -ne 0
 353        do
 354                case "$1" in
 355                -q|--quiet)
 356                        GIT_QUIET=1
 357                        ;;
 358                --)
 359                        shift
 360                        break
 361                        ;;
 362                -*)
 363                        usage
 364                        ;;
 365                *)
 366                        break
 367                        ;;
 368                esac
 369                shift
 370        done
 371
 372        git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
 373}
 374
 375#
 376# Unregister submodules from .git/config and remove their work tree
 377#
 378cmd_deinit()
 379{
 380        # parse $args after "submodule ... deinit".
 381        deinit_all=
 382        while test $# -ne 0
 383        do
 384                case "$1" in
 385                -f|--force)
 386                        force=$1
 387                        ;;
 388                -q|--quiet)
 389                        GIT_QUIET=1
 390                        ;;
 391                --all)
 392                        deinit_all=t
 393                        ;;
 394                --)
 395                        shift
 396                        break
 397                        ;;
 398                -*)
 399                        usage
 400                        ;;
 401                *)
 402                        break
 403                        ;;
 404                esac
 405                shift
 406        done
 407
 408        if test -n "$deinit_all" && test "$#" -ne 0
 409        then
 410                echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
 411                usage
 412        fi
 413        if test $# = 0 && test -z "$deinit_all"
 414        then
 415                die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
 416        fi
 417
 418        {
 419                git submodule--helper list --prefix "$wt_prefix" "$@" ||
 420                echo "#unmatched"
 421        } |
 422        while read mode sha1 stage sm_path
 423        do
 424                die_if_unmatched "$mode"
 425                name=$(git submodule--helper name "$sm_path") || exit
 426
 427                displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
 428
 429                # Remove the submodule work tree (unless the user already did it)
 430                if test -d "$sm_path"
 431                then
 432                        # Protect submodules containing a .git directory
 433                        if test -d "$sm_path/.git"
 434                        then
 435                                echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
 436                                die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
 437                        fi
 438
 439                        if test -z "$force"
 440                        then
 441                                git rm -qn "$sm_path" ||
 442                                die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
 443                        fi
 444                        rm -rf "$sm_path" &&
 445                        say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
 446                        say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
 447                fi
 448
 449                mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
 450
 451                # Remove the .git/config entries (unless the user already did it)
 452                if test -n "$(git config --get-regexp submodule."$name\.")"
 453                then
 454                        # Remove the whole section so we have a clean state when
 455                        # the user later decides to init this submodule again
 456                        url=$(git config submodule."$name".url)
 457                        git config --remove-section submodule."$name" 2>/dev/null &&
 458                        say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
 459                fi
 460        done
 461}
 462
 463is_tip_reachable () (
 464        sanitize_submodule_env &&
 465        cd "$1" &&
 466        rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
 467        test -z "$rev"
 468)
 469
 470fetch_in_submodule () (
 471        sanitize_submodule_env &&
 472        cd "$1" &&
 473        case "$2" in
 474        '')
 475                git fetch ;;
 476        *)
 477                git fetch $(get_default_remote) "$2" ;;
 478        esac
 479)
 480
 481#
 482# Update each submodule path to correct revision, using clone and checkout as needed
 483#
 484# $@ = requested paths (default to all)
 485#
 486cmd_update()
 487{
 488        # parse $args after "submodule ... update".
 489        while test $# -ne 0
 490        do
 491                case "$1" in
 492                -q|--quiet)
 493                        GIT_QUIET=1
 494                        ;;
 495                -i|--init)
 496                        init=1
 497                        ;;
 498                --remote)
 499                        remote=1
 500                        ;;
 501                -N|--no-fetch)
 502                        nofetch=1
 503                        ;;
 504                -f|--force)
 505                        force=$1
 506                        ;;
 507                -r|--rebase)
 508                        update="rebase"
 509                        ;;
 510                --reference)
 511                        case "$2" in '') usage ;; esac
 512                        reference="--reference=$2"
 513                        shift
 514                        ;;
 515                --reference=*)
 516                        reference="$1"
 517                        ;;
 518                -m|--merge)
 519                        update="merge"
 520                        ;;
 521                --recursive)
 522                        recursive=1
 523                        ;;
 524                --checkout)
 525                        update="checkout"
 526                        ;;
 527                --depth)
 528                        case "$2" in '') usage ;; esac
 529                        depth="--depth=$2"
 530                        shift
 531                        ;;
 532                --depth=*)
 533                        depth=$1
 534                        ;;
 535                -j|--jobs)
 536                        case "$2" in '') usage ;; esac
 537                        jobs="--jobs=$2"
 538                        shift
 539                        ;;
 540                --jobs=*)
 541                        jobs=$1
 542                        ;;
 543                --)
 544                        shift
 545                        break
 546                        ;;
 547                -*)
 548                        usage
 549                        ;;
 550                *)
 551                        break
 552                        ;;
 553                esac
 554                shift
 555        done
 556
 557        if test -n "$init"
 558        then
 559                cmd_init "--" "$@" || return
 560        fi
 561
 562        {
 563        git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
 564                ${wt_prefix:+--prefix "$wt_prefix"} \
 565                ${prefix:+--recursive-prefix "$prefix"} \
 566                ${update:+--update "$update"} \
 567                ${reference:+--reference "$reference"} \
 568                ${depth:+--depth "$depth"} \
 569                ${jobs:+$jobs} \
 570                "$@" || echo "#unmatched"
 571        } | {
 572        err=
 573        while read mode sha1 stage just_cloned sm_path
 574        do
 575                die_if_unmatched "$mode"
 576
 577                name=$(git submodule--helper name "$sm_path") || exit
 578                url=$(git config submodule."$name".url)
 579                branch=$(get_submodule_config "$name" branch master)
 580                if ! test -z "$update"
 581                then
 582                        update_module=$update
 583                else
 584                        update_module=$(git config submodule."$name".update)
 585                        if test -z "$update_module"
 586                        then
 587                                update_module="checkout"
 588                        fi
 589                fi
 590
 591                displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
 592
 593                if test $just_cloned -eq 1
 594                then
 595                        subsha1=
 596                        update_module=checkout
 597                else
 598                        subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
 599                                git rev-parse --verify HEAD) ||
 600                        die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
 601                fi
 602
 603                if test -n "$remote"
 604                then
 605                        if test -z "$nofetch"
 606                        then
 607                                # Fetch remote before determining tracking $sha1
 608                                (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
 609                                die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
 610                        fi
 611                        remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
 612                        sha1=$(sanitize_submodule_env; cd "$sm_path" &&
 613                                git rev-parse --verify "${remote_name}/${branch}") ||
 614                        die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
 615                fi
 616
 617                if test "$subsha1" != "$sha1" || test -n "$force"
 618                then
 619                        subforce=$force
 620                        # If we don't already have a -f flag and the submodule has never been checked out
 621                        if test -z "$subsha1" && test -z "$force"
 622                        then
 623                                subforce="-f"
 624                        fi
 625
 626                        if test -z "$nofetch"
 627                        then
 628                                # Run fetch only if $sha1 isn't present or it
 629                                # is not reachable from a ref.
 630                                is_tip_reachable "$sm_path" "$sha1" ||
 631                                fetch_in_submodule "$sm_path" ||
 632                                die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
 633
 634                                # Now we tried the usual fetch, but $sha1 may
 635                                # not be reachable from any of the refs
 636                                is_tip_reachable "$sm_path" "$sha1" ||
 637                                fetch_in_submodule "$sm_path" "$sha1" ||
 638                                die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
 639                        fi
 640
 641                        must_die_on_failure=
 642                        case "$update_module" in
 643                        checkout)
 644                                command="git checkout $subforce -q"
 645                                die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
 646                                say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
 647                                ;;
 648                        rebase)
 649                                command="git rebase"
 650                                die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
 651                                say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
 652                                must_die_on_failure=yes
 653                                ;;
 654                        merge)
 655                                command="git merge"
 656                                die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
 657                                say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
 658                                must_die_on_failure=yes
 659                                ;;
 660                        !*)
 661                                command="${update_module#!}"
 662                                die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
 663                                say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
 664                                must_die_on_failure=yes
 665                                ;;
 666                        *)
 667                                die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
 668                        esac
 669
 670                        if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
 671                        then
 672                                say "$say_msg"
 673                        elif test -n "$must_die_on_failure"
 674                        then
 675                                die_with_status 2 "$die_msg"
 676                        else
 677                                err="${err};$die_msg"
 678                                continue
 679                        fi
 680                fi
 681
 682                if test -n "$recursive"
 683                then
 684                        (
 685                                prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
 686                                wt_prefix=
 687                                sanitize_submodule_env
 688                                cd "$sm_path" &&
 689                                eval cmd_update
 690                        )
 691                        res=$?
 692                        if test $res -gt 0
 693                        then
 694                                die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
 695                                if test $res -eq 1
 696                                then
 697                                        err="${err};$die_msg"
 698                                        continue
 699                                else
 700                                        die_with_status $res "$die_msg"
 701                                fi
 702                        fi
 703                fi
 704        done
 705
 706        if test -n "$err"
 707        then
 708                OIFS=$IFS
 709                IFS=';'
 710                for e in $err
 711                do
 712                        if test -n "$e"
 713                        then
 714                                echo >&2 "$e"
 715                        fi
 716                done
 717                IFS=$OIFS
 718                exit 1
 719        fi
 720        }
 721}
 722
 723set_name_rev () {
 724        revname=$( (
 725                sanitize_submodule_env
 726                cd "$1" && {
 727                        git describe "$2" 2>/dev/null ||
 728                        git describe --tags "$2" 2>/dev/null ||
 729                        git describe --contains "$2" 2>/dev/null ||
 730                        git describe --all --always "$2"
 731                }
 732        ) )
 733        test -z "$revname" || revname=" ($revname)"
 734}
 735#
 736# Show commit summary for submodules in index or working tree
 737#
 738# If '--cached' is given, show summary between index and given commit,
 739# or between working tree and given commit
 740#
 741# $@ = [commit (default 'HEAD'),] requested paths (default all)
 742#
 743cmd_summary() {
 744        summary_limit=-1
 745        for_status=
 746        diff_cmd=diff-index
 747
 748        # parse $args after "submodule ... summary".
 749        while test $# -ne 0
 750        do
 751                case "$1" in
 752                --cached)
 753                        cached="$1"
 754                        ;;
 755                --files)
 756                        files="$1"
 757                        ;;
 758                --for-status)
 759                        for_status="$1"
 760                        ;;
 761                -n|--summary-limit)
 762                        summary_limit="$2"
 763                        isnumber "$summary_limit" || usage
 764                        shift
 765                        ;;
 766                --summary-limit=*)
 767                        summary_limit="${1#--summary-limit=}"
 768                        isnumber "$summary_limit" || usage
 769                        ;;
 770                --)
 771                        shift
 772                        break
 773                        ;;
 774                -*)
 775                        usage
 776                        ;;
 777                *)
 778                        break
 779                        ;;
 780                esac
 781                shift
 782        done
 783
 784        test $summary_limit = 0 && return
 785
 786        if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
 787        then
 788                head=$rev
 789                test $# = 0 || shift
 790        elif test -z "$1" || test "$1" = "HEAD"
 791        then
 792                # before the first commit: compare with an empty tree
 793                head=$(git hash-object -w -t tree --stdin </dev/null)
 794                test -z "$1" || shift
 795        else
 796                head="HEAD"
 797        fi
 798
 799        if [ -n "$files" ]
 800        then
 801                test -n "$cached" &&
 802                die "$(gettext "The --cached option cannot be used with the --files option")"
 803                diff_cmd=diff-files
 804                head=
 805        fi
 806
 807        cd_to_toplevel
 808        eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
 809        # Get modified modules cared by user
 810        modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
 811                sane_egrep '^:([0-7]* )?160000' |
 812                while read mod_src mod_dst sha1_src sha1_dst status sm_path
 813                do
 814                        # Always show modules deleted or type-changed (blob<->module)
 815                        if test "$status" = D || test "$status" = T
 816                        then
 817                                printf '%s\n' "$sm_path"
 818                                continue
 819                        fi
 820                        # Respect the ignore setting for --for-status.
 821                        if test -n "$for_status"
 822                        then
 823                                name=$(git submodule--helper name "$sm_path")
 824                                ignore_config=$(get_submodule_config "$name" ignore none)
 825                                test $status != A && test $ignore_config = all && continue
 826                        fi
 827                        # Also show added or modified modules which are checked out
 828                        GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
 829                        printf '%s\n' "$sm_path"
 830                done
 831        )
 832
 833        test -z "$modules" && return
 834
 835        git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
 836        sane_egrep '^:([0-7]* )?160000' |
 837        cut -c2- |
 838        while read mod_src mod_dst sha1_src sha1_dst status name
 839        do
 840                if test -z "$cached" &&
 841                        test $sha1_dst = 0000000000000000000000000000000000000000
 842                then
 843                        case "$mod_dst" in
 844                        160000)
 845                                sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
 846                                ;;
 847                        100644 | 100755 | 120000)
 848                                sha1_dst=$(git hash-object $name)
 849                                ;;
 850                        000000)
 851                                ;; # removed
 852                        *)
 853                                # unexpected type
 854                                eval_gettextln "unexpected mode \$mod_dst" >&2
 855                                continue ;;
 856                        esac
 857                fi
 858                missing_src=
 859                missing_dst=
 860
 861                test $mod_src = 160000 &&
 862                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
 863                missing_src=t
 864
 865                test $mod_dst = 160000 &&
 866                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
 867                missing_dst=t
 868
 869                display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
 870
 871                total_commits=
 872                case "$missing_src,$missing_dst" in
 873                t,)
 874                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
 875                        ;;
 876                ,t)
 877                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
 878                        ;;
 879                t,t)
 880                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
 881                        ;;
 882                *)
 883                        errmsg=
 884                        total_commits=$(
 885                        if test $mod_src = 160000 && test $mod_dst = 160000
 886                        then
 887                                range="$sha1_src...$sha1_dst"
 888                        elif test $mod_src = 160000
 889                        then
 890                                range=$sha1_src
 891                        else
 892                                range=$sha1_dst
 893                        fi
 894                        GIT_DIR="$name/.git" \
 895                        git rev-list --first-parent $range -- | wc -l
 896                        )
 897                        total_commits=" ($(($total_commits + 0)))"
 898                        ;;
 899                esac
 900
 901                sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
 902                sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
 903                if test $status = T
 904                then
 905                        blob="$(gettext "blob")"
 906                        submodule="$(gettext "submodule")"
 907                        if test $mod_dst = 160000
 908                        then
 909                                echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
 910                        else
 911                                echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
 912                        fi
 913                else
 914                        echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
 915                fi
 916                if test -n "$errmsg"
 917                then
 918                        # Don't give error msg for modification whose dst is not submodule
 919                        # i.e. deleted or changed to blob
 920                        test $mod_dst = 160000 && echo "$errmsg"
 921                else
 922                        if test $mod_src = 160000 && test $mod_dst = 160000
 923                        then
 924                                limit=
 925                                test $summary_limit -gt 0 && limit="-$summary_limit"
 926                                GIT_DIR="$name/.git" \
 927                                git log $limit --pretty='format:  %m %s' \
 928                                --first-parent $sha1_src...$sha1_dst
 929                        elif test $mod_dst = 160000
 930                        then
 931                                GIT_DIR="$name/.git" \
 932                                git log --pretty='format:  > %s' -1 $sha1_dst
 933                        else
 934                                GIT_DIR="$name/.git" \
 935                                git log --pretty='format:  < %s' -1 $sha1_src
 936                        fi
 937                        echo
 938                fi
 939                echo
 940        done
 941}
 942#
 943# List all submodules, prefixed with:
 944#  - submodule not initialized
 945#  + different revision checked out
 946#
 947# If --cached was specified the revision in the index will be printed
 948# instead of the currently checked out revision.
 949#
 950# $@ = requested paths (default to all)
 951#
 952cmd_status()
 953{
 954        # parse $args after "submodule ... status".
 955        while test $# -ne 0
 956        do
 957                case "$1" in
 958                -q|--quiet)
 959                        GIT_QUIET=1
 960                        ;;
 961                --cached)
 962                        cached=1
 963                        ;;
 964                --recursive)
 965                        recursive=1
 966                        ;;
 967                --)
 968                        shift
 969                        break
 970                        ;;
 971                -*)
 972                        usage
 973                        ;;
 974                *)
 975                        break
 976                        ;;
 977                esac
 978                shift
 979        done
 980
 981        {
 982                git submodule--helper list --prefix "$wt_prefix" "$@" ||
 983                echo "#unmatched"
 984        } |
 985        while read mode sha1 stage sm_path
 986        do
 987                die_if_unmatched "$mode"
 988                name=$(git submodule--helper name "$sm_path") || exit
 989                url=$(git config submodule."$name".url)
 990                displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
 991                if test "$stage" = U
 992                then
 993                        say "U$sha1 $displaypath"
 994                        continue
 995                fi
 996                if test -z "$url" ||
 997                {
 998                        ! test -d "$sm_path"/.git &&
 999                        ! test -f "$sm_path"/.git
1000                }
1001                then
1002                        say "-$sha1 $displaypath"
1003                        continue;
1004                fi
1005                if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1006                then
1007                        set_name_rev "$sm_path" "$sha1"
1008                        say " $sha1 $displaypath$revname"
1009                else
1010                        if test -z "$cached"
1011                        then
1012                                sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1013                        fi
1014                        set_name_rev "$sm_path" "$sha1"
1015                        say "+$sha1 $displaypath$revname"
1016                fi
1017
1018                if test -n "$recursive"
1019                then
1020                        (
1021                                prefix="$displaypath/"
1022                                sanitize_submodule_env
1023                                wt_prefix=
1024                                cd "$sm_path" &&
1025                                eval cmd_status
1026                        ) ||
1027                        die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1028                fi
1029        done
1030}
1031#
1032# Sync remote urls for submodules
1033# This makes the value for remote.$remote.url match the value
1034# specified in .gitmodules.
1035#
1036cmd_sync()
1037{
1038        while test $# -ne 0
1039        do
1040                case "$1" in
1041                -q|--quiet)
1042                        GIT_QUIET=1
1043                        shift
1044                        ;;
1045                --recursive)
1046                        recursive=1
1047                        shift
1048                        ;;
1049                --)
1050                        shift
1051                        break
1052                        ;;
1053                -*)
1054                        usage
1055                        ;;
1056                *)
1057                        break
1058                        ;;
1059                esac
1060        done
1061        cd_to_toplevel
1062        {
1063                git submodule--helper list --prefix "$wt_prefix" "$@" ||
1064                echo "#unmatched"
1065        } |
1066        while read mode sha1 stage sm_path
1067        do
1068                die_if_unmatched "$mode"
1069                name=$(git submodule--helper name "$sm_path")
1070                url=$(git config -f .gitmodules --get submodule."$name".url)
1071
1072                # Possibly a url relative to parent
1073                case "$url" in
1074                ./*|../*)
1075                        # rewrite foo/bar as ../.. to find path from
1076                        # submodule work tree to superproject work tree
1077                        up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1078                        # guarantee a trailing /
1079                        up_path=${up_path%/}/ &&
1080                        # path from submodule work tree to submodule origin repo
1081                        sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1082                        # path from superproject work tree to submodule origin repo
1083                        super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1084                        ;;
1085                *)
1086                        sub_origin_url="$url"
1087                        super_config_url="$url"
1088                        ;;
1089                esac
1090
1091                if git config "submodule.$name.url" >/dev/null 2>/dev/null
1092                then
1093                        displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1094                        say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1095                        git config submodule."$name".url "$super_config_url"
1096
1097                        if test -e "$sm_path"/.git
1098                        then
1099                        (
1100                                sanitize_submodule_env
1101                                cd "$sm_path"
1102                                remote=$(get_default_remote)
1103                                git config remote."$remote".url "$sub_origin_url"
1104
1105                                if test -n "$recursive"
1106                                then
1107                                        prefix="$prefix$sm_path/"
1108                                        eval cmd_sync
1109                                fi
1110                        )
1111                        fi
1112                fi
1113        done
1114}
1115
1116# This loop parses the command line arguments to find the
1117# subcommand name to dispatch.  Parsing of the subcommand specific
1118# options are primarily done by the subcommand implementations.
1119# Subcommand specific options such as --branch and --cached are
1120# parsed here as well, for backward compatibility.
1121
1122while test $# != 0 && test -z "$command"
1123do
1124        case "$1" in
1125        add | foreach | init | deinit | update | status | summary | sync)
1126                command=$1
1127                ;;
1128        -q|--quiet)
1129                GIT_QUIET=1
1130                ;;
1131        -b|--branch)
1132                case "$2" in
1133                '')
1134                        usage
1135                        ;;
1136                esac
1137                branch="$2"; shift
1138                ;;
1139        --cached)
1140                cached="$1"
1141                ;;
1142        --)
1143                break
1144                ;;
1145        -*)
1146                usage
1147                ;;
1148        *)
1149                break
1150                ;;
1151        esac
1152        shift
1153done
1154
1155# No command word defaults to "status"
1156if test -z "$command"
1157then
1158    if test $# = 0
1159    then
1160        command=status
1161    else
1162        usage
1163    fi
1164fi
1165
1166# "-b branch" is accepted only by "add"
1167if test -n "$branch" && test "$command" != add
1168then
1169        usage
1170fi
1171
1172# "--cached" is accepted only by "status" and "summary"
1173if test -n "$cached" && test "$command" != status && test "$command" != summary
1174then
1175        usage
1176fi
1177
1178"cmd_$command" "$@"